diff --git a/kernel/bc/beancounter.c b/kernel/bc/beancounter.c
index 64648b9..bf63b32 100644
--- a/kernel/bc/beancounter.c
+++ b/kernel/bc/beancounter.c
@@ -43,6 +43,28 @@
 #include <bc/dcache.h>
 #include <bc/proc.h>
 
+/* set by kernel boot line */
+__u64 ubc_allowed = (1 << UB_PRIVVMPAGES) |
+		    (1 << UB_PHYSPAGES) |
+		    (1 << UB_NUMPROC);
+
+/* Process kernel command-line parameter at boot time.  ubc_allowed=$mask */
+static int __init ubc_enable(char *str)
+{
+	int i;
+
+	ubc_allowed = simple_strtol(str, NULL, 0);
+	printk(KERN_INFO "UBC resources allowed: ");
+	for (i=0; i<32; i++)
+		if (ubc_allowed & (1 << i))
+			printk(KERN_INFO "%s ", ub_rnames[i]);
+
+	printk(KERN_INFO "\n");
+
+	return 1;
+}
+__setup("ubc_allowed=", ubc_enable);
+
 static struct kmem_cache *ub_cachep;
 
 struct user_beancounter ub0 = {
@@ -88,7 +110,9 @@ unsigned int ub_dcache_time_thresh __read_mostly = 5;
 unsigned int ub_dcache_no_vzfs_cache __read_mostly = 0;
 EXPORT_SYMBOL(ub_dcache_no_vzfs_cache);
 
-static int ubc_ioprio = 1;
+static int ubc_ioprio = 0;
+
+#define ubc_cgroup	blkio_subsys_id
 
 static int ubc_pagecache_isolation = 0;
 
@@ -157,6 +181,7 @@ void ub_precharge_snapshot(struct user_beancounter *ub, int *precharge)
 	precharge[UB_PHYSPAGES] += precharge[UB_KMEMSIZE] >> PAGE_SHIFT;
 	precharge[UB_OOMGUARPAGES] = precharge[UB_SWAPPAGES];
 }
+EXPORT_SYMBOL(ub_precharge_snapshot);
 
 static void forbid_beancounter_precharge(struct user_beancounter *ub, int val)
 {
@@ -177,7 +202,8 @@ LIST_HEAD(ub_list_head); /* protected by ub_hash_lock */
 EXPORT_SYMBOL(ub_list_head);
 LIST_HEAD(ub_leaked_list);
 
-static struct cgroup *ub_cgroup_root;
+struct cgroup *ub_cgroup_root;
+EXPORT_SYMBOL(ub_cgroup_root);
 
 int set_task_exec_ub(struct task_struct *tsk, struct user_beancounter *ub)
 {
@@ -196,6 +222,25 @@ int set_task_exec_ub(struct task_struct *tsk, struct user_beancounter *ub)
 }
 EXPORT_SYMBOL(set_task_exec_ub);
 
+int push_task_ub(struct task_struct *tsk, struct user_beancounter *ub,
+		 struct user_beancounter **old_ub,
+		 struct cgroup **old_cg)
+{
+	int err;
+
+	if (ub->ub_cgroup) {
+		*old_cg = task_cgroup(current, ubc_cgroup);
+		err = cgroup_kernel_attach(ub->ub_cgroup, tsk);
+		if (err)
+			return err;
+	}
+
+	*old_ub = tsk->task_bc.exec_ub;
+	tsk->task_bc.exec_ub = get_beancounter_longterm(ub);
+	return 0;
+}
+EXPORT_SYMBOL(push_task_ub);
+
 /*
  *	Per user resource beancounting. Resources are tied to their luid.
  *	The resource structure itself is tagged both to the process and
@@ -870,6 +915,7 @@ void __init ub_init_early(void)
 	(void)set_exec_ub(ub);
 	current->task_bc.task_ub = get_beancounter_longterm(ub);
 	__charge_beancounter_locked(ub, UB_NUMPROC, 1, UB_FORCE);
+	current->task_bc.fork_sub = NULL;
 	init_mm.mm_ub = get_beancounter_longterm(ub);
 
 	hlist_add_head(&ub->ub_hash, &ub_hash[ub->ub_uid]);
@@ -1099,7 +1145,7 @@ int __init ub_init_cgroup(void)
 	struct vfsmount *mnt;
 	struct cgroup_sb_opts opts = {
 		.name		= "beancounter",
-		.subsys_bits    = 1ul << blkio_subsys_id,
+		.subsys_bits    = 1ul << ubc_cgroup,
 	};
 
 	mnt = cgroup_kernel_mount(&opts);
diff --git a/kernel/bc/kmem.c b/kernel/bc/kmem.c
index 127af33..99fe160 100644
--- a/kernel/bc/kmem.c
+++ b/kernel/bc/kmem.c
@@ -33,6 +33,9 @@ int __ub_kmem_charge(struct user_beancounter *ub,
 	int kmem_strict, phys_strict;
 	int do_precharge = 1;
 
+	if (!ub_param_allow(UB_KMEMSIZE))
+		ub = get_ub0();
+
 	charge = size + (ub->ub_parms[UB_KMEMSIZE].max_precharge >> 1);
 	pages = PAGE_ALIGN(charge) >> PAGE_SHIFT;
 
@@ -104,6 +107,9 @@ void __ub_kmem_uncharge(struct user_beancounter *ub,
 {
 	unsigned long uncharge;
 
+	if (!ub_param_allow(UB_KMEMSIZE))
+		ub = get_ub0();
+
 	spin_lock(&ub->ub_lock);
 
 	if (ub->ub_parms[UB_KMEMSIZE].max_precharge !=
@@ -128,9 +134,10 @@ EXPORT_SYMBOL(__ub_kmem_uncharge);
 int ub_slab_charge(struct kmem_cache *cachep, void *objp, gfp_t flags)
 {
 	unsigned int size;
-	struct user_beancounter *ub;
+	struct user_beancounter *ub = ub_param_allow(UB_KMEMSIZE) ?
+					get_exec_ub() : get_ub0();
 
-	ub = get_beancounter(get_exec_ub());
+	ub = get_beancounter(ub);
 	if (ub == NULL)
 		return 0;
 
diff --git a/kernel/bc/misc.c b/kernel/bc/misc.c
index 3c7aa55..c62f65c 100644
--- a/kernel/bc/misc.c
+++ b/kernel/bc/misc.c
@@ -49,10 +49,19 @@ void ub_task_uncharge(struct user_beancounter *ub)
 	ub_kmem_uncharge(ub, TASK_KMEM_SIZE);
 }
 
-void ub_task_get(struct user_beancounter *ub, struct task_struct *task)
+void ub_task_get(struct task_struct *parent, struct task_struct *task)
 {
+	struct user_beancounter *ub;
 	struct task_beancounter *new_bc = &task->task_bc;
 
+	if (parent->task_bc.fork_sub) {
+		ub = parent->task_bc.fork_sub;
+		new_bc->fork_sub = get_beancounter_longterm(ub);
+	} else {
+		ub = get_exec_ub();
+		new_bc->fork_sub = NULL;
+	}
+
 	new_bc->task_ub = get_beancounter_longterm(ub);
 	new_bc->exec_ub = get_beancounter_longterm(ub);
 }
@@ -65,14 +74,18 @@ void ub_task_put(struct task_struct *task)
 
 	put_beancounter_longterm(task_bc->exec_ub);
 	put_beancounter_longterm(task_bc->task_ub);
+	if (task_bc->fork_sub)
+		put_beancounter_longterm(task_bc->fork_sub);
 
 	task_bc->exec_ub = (struct user_beancounter *)0xdeadbcbc;
 	task_bc->task_ub = (struct user_beancounter *)0xdead100c;
+	task_bc->fork_sub = (struct user_beancounter *)0xdead100c;
 }
 
 int ub_file_charge(struct file *f)
 {
-	struct user_beancounter *ub = get_exec_ub();
+	struct user_beancounter *ub = ub_param_allow(UB_NUMFILE) ?
+					get_exec_ub() : get_ub0();
 	int err;
 
 	err = charge_beancounter_fast(ub, UB_NUMFILE, 1, UB_HARD);
@@ -143,6 +156,9 @@ int ub_siginfo_charge(struct sigqueue *sq, struct user_beancounter *ub,
 {
 	unsigned long size;
 
+	if (!ub_param_allow(UB_NUMSIGINFO))
+		ub = get_ub0();
+
 	size = CHARGE_SIZE(kmem_obj_objuse(sq));
 	if (ub_kmem_charge(ub, size, gfp_mask))
 		goto out_kmem;
diff --git a/kernel/bc/net.c b/kernel/bc/net.c
index 2c40a6e..09beb2b 100644
--- a/kernel/bc/net.c
+++ b/kernel/bc/net.c
@@ -392,7 +392,7 @@ static int __sock_charge(struct sock *sk, int res)
 	unsigned long added_reserv, added_forw;
 	unsigned long flags;
 
-	ub = get_exec_ub();
+	ub = ub_param_allow(res) ? get_exec_ub() : get_ub0();
 	if (unlikely(ub == NULL))
 		return 0;
 
diff --git a/kernel/bc/sys.c b/kernel/bc/sys.c
index b72d5b2..ca8d65d 100644
--- a/kernel/bc/sys.c
+++ b/kernel/bc/sys.c
@@ -8,6 +8,7 @@
  *
  */
 
+#include <linux/module.h>
 #include <linux/virtinfo.h>
 #include <linux/compat.h>
 #include <linux/syscalls.h>
@@ -74,19 +75,11 @@ out:
 	return error;
 }
 
-long do_setublimit(uid_t uid, unsigned long resource,
+long do_setublimit(struct user_beancounter *ub, unsigned long resource,
 		unsigned long *new_limits)
 {
 	int error;
 	unsigned long flags;
-	struct user_beancounter *ub;
-
-	error = -EPERM;
-	if(!capable(CAP_SYS_RESOURCE))
-		goto out;
-
-	if (!ve_is_super(get_exec_env()))
-		goto out;
 
 	error = -EINVAL;
 	if (resource >= UB_RESOURCES)
@@ -96,13 +89,6 @@ long do_setublimit(uid_t uid, unsigned long resource,
 	if (new_limits[0] > UB_MAXVALUE || new_limits[1] > UB_MAXVALUE)
 		goto out;
 
-	error = -ENOENT;
-	ub = get_beancounter_byuid(uid, 0);
-	if (ub == NULL) {
-		ub_debug(UBD_LIMIT, "No login bc for uid %d\n", uid);
-		goto out;
-	}
-
 	spin_lock_irqsave(&ub->ub_lock, flags);
 	ub->ub_parms[resource].barrier = new_limits[0];
 	ub->ub_parms[resource].limit = new_limits[1];
@@ -114,6 +100,33 @@ long do_setublimit(uid_t uid, unsigned long resource,
 		set_gang_limits(get_ub_gs(ub),
 				&ub->ub_parms[UB_PHYSPAGES].limit, NULL);
 
+	error = 0;
+out:
+	return error;
+}
+EXPORT_SYMBOL(do_setublimit);
+
+long do_setublimit_by_id(uid_t uid, unsigned long resource,
+		unsigned long *new_limits)
+{
+	int error;
+	struct user_beancounter *ub;
+
+	error = -EPERM;
+	if(!capable(CAP_SYS_RESOURCE))
+		goto out;
+
+	if (!ve_is_super(get_exec_env()))
+		goto out;
+
+	error = -ENOENT;
+	ub = get_beancounter_byuid(uid, 0);
+	if (ub == NULL) {
+		ub_debug(UBD_LIMIT, "No login bc for uid %d\n", uid);
+		goto out;
+	}
+
+	error = do_setublimit(ub, resource, new_limits);
 	put_beancounter_longterm(ub);
 
 	error = 0;
@@ -132,7 +145,7 @@ SYSCALL_DEFINE3(setublimit, uid_t, uid, unsigned long, resource,
 	if (copy_from_user(&new_limits, limits, sizeof(new_limits)))
 		return -EFAULT;
 
-	return do_setublimit(uid, resource, new_limits);
+	return do_setublimit_by_id(uid, resource, new_limits);
 }
 
 extern long do_ubstat(int func, unsigned long arg1, unsigned long arg2, 
@@ -168,7 +181,7 @@ asmlinkage long compat_sys_setublimit(uid_t uid,
 	if (u_new_limits[1] == UB_MAXVALUE_COMPAT)
 		new_limits[1] = UB_MAXVALUE;
 
-	return do_setublimit(uid, resource, new_limits);
+	return do_setublimit_by_id(uid, resource, new_limits);
 }
 
 asmlinkage long compat_sys_ubstat(int func, unsigned int arg1,
diff --git a/kernel/cgroup.c b/kernel/cgroup.c
index 43731cd..67c8668 100644
--- a/kernel/cgroup.c
+++ b/kernel/cgroup.c
@@ -81,7 +81,7 @@
  * B happens only through cgroup_show_options() and using cgroup_root_mutex
  * breaks it.
  */
-static DEFINE_MUTEX(cgroup_mutex);
+static DECLARE_RWSEM(cgroup_rwsem);
 static DEFINE_MUTEX(cgroup_root_mutex);
 
 /* Generate an array of cgroup subsystem pointers */
@@ -659,7 +659,7 @@ static struct cgroup *task_cgroup_from_root(struct task_struct *task,
 	struct css_set *css;
 	struct cgroup *res = NULL;
 
-	BUG_ON(!mutex_is_locked(&cgroup_mutex));
+	BUG_ON(!rwsem_is_locked(&cgroup_rwsem));
 	read_lock(&css_set_lock);
 	/*
 	 * No need to lock the task - since we hold cgroup_mutex the
@@ -774,20 +774,34 @@ EXPORT_SYMBOL(cpt_collect_cgroups);
  * cgroup_lock - lock out any changes to cgroup structures
  *
  */
+void cgroup_lock_read(void)
+{
+	down_read(&cgroup_rwsem);
+}
+EXPORT_SYMBOL(cgroup_lock_read);
+
 void cgroup_lock(void)
 {
-	mutex_lock(&cgroup_mutex);
+	down_write(&cgroup_rwsem);
 }
+EXPORT_SYMBOL(cgroup_lock);
 
 /**
  * cgroup_unlock - release lock on cgroup changes
  *
  * Undo the lock taken in a previous cgroup_lock() call.
  */
+void cgroup_unlock_read(void)
+{
+	up_read(&cgroup_rwsem);
+}
+EXPORT_SYMBOL(cgroup_unlock_read);
+
 void cgroup_unlock(void)
 {
-	mutex_unlock(&cgroup_mutex);
+	up_write(&cgroup_rwsem);
 }
+EXPORT_SYMBOL(cgroup_unlock);
 
 /*
  * A couple of forward declarations required, due to cyclic reference loop:
@@ -860,6 +874,37 @@ static void free_cgroup_rcu(struct rcu_head *obj)
 {
 	struct cgroup *cgrp = container_of(obj, struct cgroup, rcu_head);
 
+	schedule_work(&cgrp->free_work);
+}
+
+static void cgroup_free_fn(struct work_struct *work)
+{
+	struct cgroup *cgrp = container_of(work, struct cgroup, free_work);
+	struct cgroup_subsys *ss;
+
+	down_write(&cgroup_rwsem);
+	/*
+	 * Release the subsystem state objects.
+	 */
+	for_each_subsys(cgrp->root, ss)
+		ss->destroy(ss, cgrp);
+
+	cgrp->root->number_of_cgroups--;
+	kfree(cgrp->release_agent);
+	up_write(&cgroup_rwsem);
+
+	/*
+	 * Drop the active superblock reference that we took when we
+	 * created the cgroup
+	 */
+	deactivate_super(cgrp->root->sb);
+
+	/*
+	 * if we're getting rid of the cgroup, refcount should ensure
+	 * that there are no pidlists left.
+	 */
+	BUG_ON(!list_empty(&cgrp->pidlists));
+
 	kfree(cgrp);
 }
 
@@ -868,7 +913,7 @@ static void cgroup_diput(struct dentry *dentry, struct inode *inode)
 	/* is dentry a directory ? if so, kfree() associated cgroup */
 	if (S_ISDIR(inode->i_mode)) {
 		struct cgroup *cgrp = dentry->d_fsdata;
-		struct cgroup_subsys *ss;
+
 		BUG_ON(!(cgroup_is_removed(cgrp)));
 		/* It's possible for external users to be holding css
 		 * reference counts on a cgroup; css_put() needs to
@@ -876,31 +921,6 @@ static void cgroup_diput(struct dentry *dentry, struct inode *inode)
 		 * the reference count in order to know if it needs to
 		 * queue the cgroup to be handled by the release
 		 * agent */
-		synchronize_rcu();
-
-		mutex_lock(&cgroup_mutex);
-		/*
-		 * Release the subsystem state objects.
-		 */
-		for_each_subsys(cgrp->root, ss)
-			ss->destroy(ss, cgrp);
-
-		cgrp->root->number_of_cgroups--;
-		kfree(cgrp->release_agent);
-		mutex_unlock(&cgroup_mutex);
-
-		/*
-		 * Drop the active superblock reference that we took when we
-		 * created the cgroup
-		 */
-		deactivate_super(cgrp->root->sb);
-
-		/*
-		 * if we're getting rid of the cgroup, refcount should ensure
-		 * that there are no pidlists left.
-		 */
-		BUG_ON(!list_empty(&cgrp->pidlists));
-
 		call_rcu(&cgrp->rcu_head, free_cgroup_rcu);
 	}
 	iput(inode);
@@ -1205,7 +1225,7 @@ static int cgroup_remount(struct super_block *sb, int *flags, char *data)
 
 	lock_kernel();
 	mutex_lock(&cgrp->dentry->d_inode->i_mutex);
-	mutex_lock(&cgroup_mutex);
+	down_write(&cgroup_rwsem);
 	mutex_lock(&cgroup_root_mutex);
 
 	/* See what subsystems are wanted */
@@ -1241,7 +1261,7 @@ static int cgroup_remount(struct super_block *sb, int *flags, char *data)
 	kfree(opts.release_agent);
 	kfree(opts.name);
 	mutex_unlock(&cgroup_root_mutex);
-	mutex_unlock(&cgroup_mutex);
+	up_write(&cgroup_rwsem);
 	mutex_unlock(&cgrp->dentry->d_inode->i_mutex);
 	unlock_kernel();
 	return ret;
@@ -1261,6 +1281,7 @@ static void init_cgroup_housekeeping(struct cgroup *cgrp)
 	INIT_LIST_HEAD(&cgrp->css_sets);
 	INIT_LIST_HEAD(&cgrp->release_list);
 	INIT_LIST_HEAD(&cgrp->pidlists);
+	INIT_WORK(&cgrp->free_work, cgroup_free_fn);
 	mutex_init(&cgrp->pidlist_mutex);
 	INIT_LIST_HEAD(&cgrp->event_list);
 	spin_lock_init(&cgrp->event_list_lock);
@@ -1468,7 +1489,7 @@ static int cgroup_get_sb(struct file_system_type *fs_type,
 		inode = sb->s_root->d_inode;
 
 		mutex_lock(&inode->i_mutex);
-		mutex_lock(&cgroup_mutex);
+		down_write(&cgroup_rwsem);
 		mutex_lock(&cgroup_root_mutex);
 
 		/* Check for name clashes with existing mounts */
@@ -1485,6 +1506,7 @@ static int cgroup_get_sb(struct file_system_type *fs_type,
 		 * that's us. The worst that can happen is that we
 		 * have some link structures left over
 		 */
+
 		ret = allocate_cg_links(css_set_count, &tmp_cg_links);
 		if (ret)
 			goto unlock_drop;
@@ -1535,7 +1557,7 @@ static int cgroup_get_sb(struct file_system_type *fs_type,
 		cgroup_populate_dir(root_cgrp);
 		revert_creds(cred);
 		mutex_unlock(&cgroup_root_mutex);
-		mutex_unlock(&cgroup_mutex);
+		up_write(&cgroup_rwsem);
 		mutex_unlock(&inode->i_mutex);
 	} else {
 		/*
@@ -1571,14 +1593,14 @@ static int cgroup_get_sb(struct file_system_type *fs_type,
 			 * Register independent release agent for this fake top cgroup
 			 */
 			mutex_lock(&top_cgrp->dentry->d_inode->i_mutex);
-			mutex_lock(&cgroup_mutex);
+			down_write(&cgroup_rwsem);
 			mutex_lock(&cgroup_root_mutex);
 			top_cgrp->release_agent = opts.release_agent;
 			opts.release_agent = NULL;
 			top_cgrp->top_cgroup = top_cgrp;
 			cgroup_populate_dir(top_cgrp);
 			mutex_unlock(&cgroup_root_mutex);
-			mutex_unlock(&cgroup_mutex);
+			up_write(&cgroup_rwsem);
 			mutex_unlock(&top_cgrp->dentry->d_inode->i_mutex);
 		}
 
@@ -1598,7 +1620,7 @@ static int cgroup_get_sb(struct file_system_type *fs_type,
 
  unlock_drop:
 	mutex_unlock(&cgroup_root_mutex);
-	mutex_unlock(&cgroup_mutex);
+	up_write(&cgroup_rwsem);
 	mutex_unlock(&inode->i_mutex);
  drop_new_super:
 	deactivate_locked_super(sb);
@@ -1622,7 +1644,7 @@ static void cgroup_kill_sb(struct super_block *sb) {
 	BUG_ON(!list_empty(&cgrp->children));
 	BUG_ON(!list_empty(&cgrp->sibling));
 
-	mutex_lock(&cgroup_mutex);
+	down_write(&cgroup_rwsem);
 	mutex_lock(&cgroup_root_mutex);
 
 	/* Rebind all subsystems back to the default hierarchy */
@@ -1650,7 +1672,7 @@ static void cgroup_kill_sb(struct super_block *sb) {
 	}
 
 	mutex_unlock(&cgroup_root_mutex);
-	mutex_unlock(&cgroup_mutex);
+	up_write(&cgroup_rwsem);
 
 	kill_litter_super(sb);
 	cgroup_drop_root(root);
@@ -1722,6 +1744,7 @@ int cgroup_path(const struct cgroup *cgrp, char *buf, int buflen)
 	memmove(buf, start, buf + buflen - start);
 	return 0;
 }
+EXPORT_SYMBOL(cgroup_path);
 
 /*
  * cgroup_task_migrate - move a task from one cgroup to another.
@@ -1871,6 +1894,7 @@ out:
 	}
 	return retval;
 }
+EXPORT_SYMBOL(cgroup_attach_task);
 
 /**
  * cgroup_attach_task_all - attach task 'tsk' to all cgroups of task 'from'
@@ -2273,11 +2297,21 @@ static int cgroup_procs_write(struct cgroup *cgrp, struct cftype *cft, u64 tgid)
  * On success, returns true; the lock should be later released with
  * cgroup_unlock(). On failure returns false with no lock held.
  */
+bool cgroup_lock_live_group_read(struct cgroup *cgrp)
+{
+	down_read(&cgroup_rwsem);
+	if (cgroup_is_removed(cgrp)) {
+		up_read(&cgroup_rwsem);
+		return false;
+	}
+	return true;
+}
+
 bool cgroup_lock_live_group(struct cgroup *cgrp)
 {
-	mutex_lock(&cgroup_mutex);
+	down_write(&cgroup_rwsem);
 	if (cgroup_is_removed(cgrp)) {
-		mutex_unlock(&cgroup_mutex);
+		up_write(&cgroup_rwsem);
 		return false;
 	}
 	return true;
@@ -3750,7 +3784,7 @@ static long cgroup_create(struct cgroup *parent, struct dentry *dentry,
 	 * fs */
 	atomic_inc(&sb->s_active);
 
-	mutex_lock(&cgroup_mutex);
+	down_write(&cgroup_rwsem);
 
 	init_cgroup_housekeeping(cgrp);
 
@@ -3792,7 +3826,7 @@ static long cgroup_create(struct cgroup *parent, struct dentry *dentry,
 	err = cgroup_populate_dir(cgrp);
 	/* If err < 0, we have a half-filled directory - oh well ;) */
 
-	mutex_unlock(&cgroup_mutex);
+	up_write(&cgroup_rwsem);
 	mutex_unlock(&cgrp->dentry->d_inode->i_mutex);
 
 	return 0;
@@ -3811,7 +3845,7 @@ static long cgroup_create(struct cgroup *parent, struct dentry *dentry,
 			ss->destroy(ss, cgrp);
 	}
 
-	mutex_unlock(&cgroup_mutex);
+	up_write(&cgroup_rwsem);
 
 	/* Release the reference count that we took on the superblock */
 	deactivate_super(sb);
@@ -3922,16 +3956,16 @@ static int cgroup_rmdir(struct inode *unused_dir, struct dentry *dentry)
 
 	/* the vfs holds both inode->i_mutex already */
 again:
-	mutex_lock(&cgroup_mutex);
+	down_write(&cgroup_rwsem);
 	if (atomic_read(&cgrp->count) != 0) {
-		mutex_unlock(&cgroup_mutex);
+		up_write(&cgroup_rwsem);
 		return -EBUSY;
 	}
 	if (!list_empty(&cgrp->children)) {
-		mutex_unlock(&cgroup_mutex);
+		up_write(&cgroup_rwsem);
 		return -EBUSY;
 	}
-	mutex_unlock(&cgroup_mutex);
+	up_write(&cgroup_rwsem);
 
 	/*
 	 * In general, subsystem has no css->refcnt after pre_destroy(). But
@@ -3954,16 +3988,16 @@ again:
 		return ret;
 	}
 
-	mutex_lock(&cgroup_mutex);
+	down_write(&cgroup_rwsem);
 	parent = cgrp->parent;
 	if (atomic_read(&cgrp->count) || !list_empty(&cgrp->children)) {
 		clear_bit(CGRP_WAIT_ON_RMDIR, &cgrp->flags);
-		mutex_unlock(&cgroup_mutex);
+		up_write(&cgroup_rwsem);
 		return -EBUSY;
 	}
 	prepare_to_wait(&cgroup_rmdir_waitq, &wait, TASK_INTERRUPTIBLE);
 	if (!cgroup_clear_css_refs(cgrp)) {
-		mutex_unlock(&cgroup_mutex);
+		up_write(&cgroup_rwsem);
 		/*
 		 * Because someone may call cgroup_wakeup_rmdir_waiter() before
 		 * prepare_to_wait(), we need to check this flag.
@@ -4001,7 +4035,7 @@ again:
 	set_bit(CGRP_RELEASABLE, &parent->flags);
 	check_for_release(parent);
 
-	mutex_unlock(&cgroup_mutex);
+	up_write(&cgroup_rwsem);
 	return 0;
 }
 
@@ -4178,7 +4212,7 @@ static int proc_cgroup_show(struct seq_file *m, void *v)
 
 	retval = 0;
 
-	mutex_lock(&cgroup_mutex);
+	down_write(&cgroup_rwsem);
 
 	for_each_active_root(root) {
 		struct cgroup_subsys *ss;
@@ -4201,7 +4235,7 @@ static int proc_cgroup_show(struct seq_file *m, void *v)
 	}
 
 out_unlock:
-	mutex_unlock(&cgroup_mutex);
+	up_write(&cgroup_rwsem);
 	put_task_struct(tsk);
 out_free:
 	kfree(buf);
@@ -4230,14 +4264,14 @@ static int proc_cgroupstats_show(struct seq_file *m, void *v)
 	seq_puts(m, "#subsys_name\thierarchy\tnum_cgroups\tenabled\n");
 	if (!ve_is_super(get_exec_env()))
 		return 0;
-	mutex_lock(&cgroup_mutex);
+	down_read(&cgroup_rwsem);
 	for (i = 0; i < CGROUP_SUBSYS_COUNT; i++) {
 		struct cgroup_subsys *ss = subsys[i];
 		seq_printf(m, "%s\t%d\t%d\t%d\n",
 			   ss->name, ss->root->hierarchy_id,
 			   ss->root->number_of_cgroups, !ss->disabled);
 	}
-	mutex_unlock(&cgroup_mutex);
+	up_read(&cgroup_rwsem);
 	return 0;
 }
 
@@ -4423,18 +4457,18 @@ int cgroup_clone(struct task_struct *tsk, struct cgroup_subsys *subsys,
 
 	/* First figure out what hierarchy and cgroup we're dealing
 	 * with, and pin them so we can drop cgroup_mutex */
-	mutex_lock(&cgroup_mutex);
+	down_write(&cgroup_rwsem);
  again:
 	root = subsys->root;
 	if (root == &rootnode) {
-		mutex_unlock(&cgroup_mutex);
+		up_write(&cgroup_rwsem);
 		return 0;
 	}
 
 	/* Pin the hierarchy */
 	if (!atomic_inc_not_zero(&root->sb->s_active)) {
 		/* We race with the final deactivate_super() */
-		mutex_unlock(&cgroup_mutex);
+		up_write(&cgroup_rwsem);
 		return 0;
 	}
 
@@ -4445,7 +4479,7 @@ int cgroup_clone(struct task_struct *tsk, struct cgroup_subsys *subsys,
 	get_css_set(cg);
 	task_unlock(tsk);
 
-	mutex_unlock(&cgroup_mutex);
+	up_write(&cgroup_rwsem);
 
 	/* Now do the VFS work to create a cgroup */
 	inode = parent->dentry->d_inode;
@@ -4476,7 +4510,7 @@ int cgroup_clone(struct task_struct *tsk, struct cgroup_subsys *subsys,
 	/* The cgroup now exists. Retake cgroup_mutex and check
 	 * that we're still in the same state that we thought we
 	 * were. */
-	mutex_lock(&cgroup_mutex);
+	down_write(&cgroup_rwsem);
 	if ((root != subsys->root) ||
 	    (parent != task_cgroup(tsk, subsys->subsys_id))) {
 		/* Aargh, we raced ... */
@@ -4501,14 +4535,14 @@ int cgroup_clone(struct task_struct *tsk, struct cgroup_subsys *subsys,
 
 	/* All seems fine. Finish by moving the task into the new cgroup */
 	ret = cgroup_attach_task(child, tsk);
-	mutex_unlock(&cgroup_mutex);
+	up_write(&cgroup_rwsem);
 
  out_release:
 	mutex_unlock(&inode->i_mutex);
 
-	mutex_lock(&cgroup_mutex);
+	down_write(&cgroup_rwsem);
 	put_css_set(cg);
-	mutex_unlock(&cgroup_mutex);
+	up_write(&cgroup_rwsem);
 	deactivate_super(root->sb);
 	return ret;
 }
@@ -4607,7 +4641,7 @@ void __css_put(struct cgroup_subsys_state *css, int count)
 static void cgroup_release_agent(struct work_struct *work)
 {
 	BUG_ON(work != &release_agent_work);
-	mutex_lock(&cgroup_mutex);
+	down_write(&cgroup_rwsem);
 	spin_lock(&release_list_lock);
 	while (!list_empty(&release_list)) {
 		char *argv[3], *envp[3];
@@ -4625,13 +4659,13 @@ static void cgroup_release_agent(struct work_struct *work)
 
 			atomic_inc(&sb->s_active);
 			dget(cgrp->dentry);
-			mutex_unlock(&cgroup_mutex);
+			up_write(&cgroup_rwsem);
 			mutex_lock_nested(&parent->i_mutex, I_MUTEX_PARENT);
 			vfs_rmdir(parent, cgrp->dentry);
 			mutex_unlock(&parent->i_mutex);
 			dput(cgrp->dentry);
 			deactivate_super(sb);
-			mutex_lock(&cgroup_mutex);
+			down_write(&cgroup_rwsem);
 			goto continue_free;
 		}
 
@@ -4661,21 +4695,21 @@ static void cgroup_release_agent(struct work_struct *work)
 		/* Drop the lock while we invoke the usermode helper,
 		 * since the exec could involve hitting disk and hence
 		 * be a slow process */
-		mutex_unlock(&cgroup_mutex);
+		up_write(&cgroup_rwsem);
 		err = call_usermodehelper_wq(argv[0], argv, envp, UMH_WAIT_EXEC,
 						cgrp->top_cgroup->khelper_wq);
 		if (err < 0)
 			pr_warn_ratelimited("cgroup release_agent "
 					    "%s %s failed: %d\n",
 					    agentbuf, pathbuf, err);
-		mutex_lock(&cgroup_mutex);
+		down_write(&cgroup_rwsem);
  continue_free:
 		kfree(pathbuf);
 		kfree(agentbuf);
 		spin_lock(&release_list_lock);
 	}
 	spin_unlock(&release_list_lock);
-	mutex_unlock(&cgroup_mutex);
+	up_write(&cgroup_rwsem);
 }
 
 static int __init cgroup_disable(char *str)
@@ -5177,9 +5211,9 @@ int cgroup_kernel_attach(struct cgroup *cgrp, struct task_struct *tsk)
 {
 	int ret;
 
-	cgroup_lock();
+	cgroup_lock_read();
 	ret = cgroup_attach_task(cgrp, tsk);
-	cgroup_unlock();
+	cgroup_unlock_read();
 	return ret;
 }
 EXPORT_SYMBOL(cgroup_kernel_attach);
diff --git a/kernel/cpuset.c b/kernel/cpuset.c
index 6c4c3f8..1365d8f 100644
--- a/kernel/cpuset.c
+++ b/kernel/cpuset.c
@@ -1464,6 +1464,7 @@ static void cpuset_attach(struct cgroup_subsys *ss, struct cgroup *cont,
 	struct mm_struct *mm;
 	struct cpuset *cs = cgroup_cs(cont);
 	struct cpuset *oldcs = cgroup_cs(oldcont);
+	int rebind = 1;
 
 	/*
 	 * Change mm, possibly for multiple threads in a threadgroup. This is
@@ -1471,9 +1472,15 @@ static void cpuset_attach(struct cgroup_subsys *ss, struct cgroup *cont,
 	 */
 	cpuset_attach_nodemask_from = oldcs->mems_allowed;
 	cpuset_attach_nodemask_to = cs->mems_allowed;
+	if (nodes_equal(cpuset_attach_nodemask_from, cpuset_attach_nodemask_to)) {
+		if (!is_memory_migrate(cs))
+			return;
+		rebind = 0;
+	}
 	mm = get_task_mm(tsk);
 	if (mm) {
-		mpol_rebind_mm(mm, &cpuset_attach_nodemask_to);
+		if (rebind)
+			mpol_rebind_mm(mm, &cpuset_attach_nodemask_to);
 		if (is_memory_migrate(cs))
 			cpuset_migrate_mm(mm, &cpuset_attach_nodemask_from,
 					  &cpuset_attach_nodemask_to);
diff --git a/kernel/exit.c b/kernel/exit.c
index 8aca68c..ff403d1 100644
--- a/kernel/exit.c
+++ b/kernel/exit.c
@@ -231,6 +231,15 @@ repeat:
 	ub_task_uncharge(p->task_bc.task_ub);
 	if (zap_ve)
 		ve_cleanup_schedule(p->ve_task_info.owner_env);
+
+	/* flush tags */
+	while(!list_empty(&p->tags_list)) {
+		struct fake_tag *tmp = list_entry(p->tags_list.next,
+						  struct fake_tag, tag_link);
+		list_del(&tmp->tag_link);
+		tmp->tag_fini(tmp);
+	}
+
 	call_rcu(&p->rcu, delayed_put_task_struct);
 
 	p = leader;
diff --git a/kernel/fairsched.c b/kernel/fairsched.c
index 9932433..0292271 100644
--- a/kernel/fairsched.c
+++ b/kernel/fairsched.c
@@ -20,7 +20,9 @@
 #include <linux/fairsched.h>
 #include <linux/uaccess.h>
 
-static struct cgroup *fairsched_root, *fairsched_host;
+struct cgroup *fairsched_root, *fairsched_host;
+EXPORT_SYMBOL(fairsched_root);
+EXPORT_SYMBOL(fairsched_host);
 
 /* fairsched use node id = INT_MAX for ve0 tasks */
 #define FAIRSCHED_HOST_NODE 2147483647
diff --git a/kernel/fork.c b/kernel/fork.c
index 46b2232..8c095a4 100644
--- a/kernel/fork.c
+++ b/kernel/fork.c
@@ -1101,6 +1101,7 @@ static struct task_struct *copy_process(unsigned long clone_flags,
 	int retval;
 	struct task_struct *p;
 	int cgroup_callbacks_done = 0;
+	struct user_beancounter *ub;
 
 	if ((clone_flags & (CLONE_NEWNS|CLONE_FS)) == (CLONE_NEWNS|CLONE_FS))
 		return ERR_PTR(-EINVAL);
@@ -1135,14 +1136,18 @@ static struct task_struct *copy_process(unsigned long clone_flags,
 		goto fork_out;
 
 	retval = -ENOMEM;
-	if (ub_task_charge(get_exec_ub()))
+	if (current->task_bc.fork_sub)
+		ub = current->task_bc.fork_sub;
+	else
+		ub = get_exec_ub();
+	if (ub_task_charge(ub))
 		goto fork_out;
 
 	p = dup_task_struct(current);
 	if (!p)
 		goto bad_fork_uncharge;
 
-	ub_task_get(get_exec_ub(), p);
+	ub_task_get(current, p);
 
 	tracehook_init_task(p);
 
@@ -1300,6 +1305,9 @@ static struct task_struct *copy_process(unsigned long clone_flags,
 		}
 	}
 
+	spin_lock_init(&p->tags_lock);
+	INIT_LIST_HEAD(&p->tags_list);
+
 	p->pid = pid_nr(pid);
 	p->tgid = p->pid;
 	if (clone_flags & CLONE_THREAD)
@@ -1479,7 +1487,7 @@ bad_fork_free:
 	ub_task_put(p);
 	free_task(p);
 bad_fork_uncharge:
-	ub_task_uncharge(get_exec_ub());
+	ub_task_uncharge(ub);
 fork_out:
 	return ERR_PTR(retval);
 }
diff --git a/kernel/nsproxy.c b/kernel/nsproxy.c
index a7f0823..83745f0 100644
--- a/kernel/nsproxy.c
+++ b/kernel/nsproxy.c
@@ -68,6 +68,12 @@ EXPORT_SYMBOL_GPL(duplicate_nsproxy);
 static struct nsproxy *create_new_namespaces(unsigned long flags,
 			struct task_struct *tsk, struct fs_struct *new_fs)
 {
+	return dup_ns(flags, tsk->nsproxy, new_fs);
+}
+
+struct nsproxy *dup_ns(unsigned long flags,
+			struct nsproxy *ns, struct fs_struct *new_fs)
+{
 	struct nsproxy *new_nsp;
 	int err;
 
@@ -75,31 +81,31 @@ static struct nsproxy *create_new_namespaces(unsigned long flags,
 	if (!new_nsp)
 		return ERR_PTR(-ENOMEM);
 
-	new_nsp->mnt_ns = copy_mnt_ns(flags, tsk->nsproxy->mnt_ns, new_fs);
+	new_nsp->mnt_ns = copy_mnt_ns(flags, ns->mnt_ns, new_fs);
 	if (IS_ERR(new_nsp->mnt_ns)) {
 		err = PTR_ERR(new_nsp->mnt_ns);
 		goto out_ns;
 	}
 
-	new_nsp->uts_ns = copy_utsname(flags, tsk->nsproxy->uts_ns);
+	new_nsp->uts_ns = copy_utsname(flags, ns->uts_ns);
 	if (IS_ERR(new_nsp->uts_ns)) {
 		err = PTR_ERR(new_nsp->uts_ns);
 		goto out_uts;
 	}
 
-	new_nsp->ipc_ns = copy_ipcs(flags, tsk->nsproxy->ipc_ns);
+	new_nsp->ipc_ns = copy_ipcs(flags, ns->ipc_ns);
 	if (IS_ERR(new_nsp->ipc_ns)) {
 		err = PTR_ERR(new_nsp->ipc_ns);
 		goto out_ipc;
 	}
 
-	new_nsp->pid_ns = copy_pid_ns(flags, tsk->nsproxy->pid_ns);
+	new_nsp->pid_ns = copy_pid_ns(flags, ns->pid_ns);
 	if (IS_ERR(new_nsp->pid_ns)) {
 		err = PTR_ERR(new_nsp->pid_ns);
 		goto out_pid;
 	}
 
-	new_nsp->net_ns = copy_net_ns(flags, tsk->nsproxy->net_ns);
+	new_nsp->net_ns = copy_net_ns(flags, ns->net_ns);
 	if (IS_ERR(new_nsp->net_ns)) {
 		err = PTR_ERR(new_nsp->net_ns);
 		goto out_net;
@@ -123,6 +129,7 @@ out_ns:
 	kmem_cache_free(nsproxy_cachep, new_nsp);
 	return ERR_PTR(err);
 }
+EXPORT_SYMBOL(dup_ns);
 
 /*
  * called from clone.  This now handles copy for nsproxy and all
@@ -259,6 +266,7 @@ int unshare_nsproxy_namespaces(unsigned long unshare_flags,
 out:
 	return err;
 }
+EXPORT_SYMBOL(unshare_nsproxy_namespaces);
 
 void switch_task_namespaces(struct task_struct *p, struct nsproxy *new)
 {
@@ -281,6 +289,7 @@ void switch_task_namespaces(struct task_struct *p, struct nsproxy *new)
 		free_nsproxy(ns);
 	}
 }
+
 EXPORT_SYMBOL_GPL(switch_task_namespaces);
 
 void exit_task_namespaces(struct task_struct *p)
diff --git a/kernel/pid.c b/kernel/pid.c
index 91a80fe..7d77021 100644
--- a/kernel/pid.c
+++ b/kernel/pid.c
@@ -343,7 +343,7 @@ struct pid *alloc_pid(struct pid_namespace *ns, pid_t vpid)
 	}
 
 #ifdef CONFIG_BEANCOUNTERS
-	ub = get_exec_ub();
+	ub = ub_param_allow(UB_KMEMSIZE) ? get_exec_ub() : get_ub0();
 	if (ub_kmem_charge(ub, kmem_cache_objuse(ns->pid_cachep), GFP_KERNEL))
 		goto out_free;
 	pid->ub = get_beancounter(ub);
diff --git a/kernel/ptrace.c b/kernel/ptrace.c
index 33c4f6c..e316a09 100644
--- a/kernel/ptrace.c
+++ b/kernel/ptrace.c
@@ -25,6 +25,8 @@
 #include <linux/regset.h>
 #include <linux/utrace.h>
 
+int user_ptrace_enabled = 1;
+
 int __ptrace_may_access(struct task_struct *task, unsigned int mode)
 {
 	const struct cred *cred = current_cred(), *tcred;
@@ -50,7 +52,8 @@ int __ptrace_may_access(struct task_struct *task, unsigned int mode)
 	     cred->uid != tcred->uid  ||
 	     cred->gid != tcred->egid ||
 	     cred->gid != tcred->sgid ||
-	     cred->gid != tcred->gid) &&
+	     cred->gid != tcred->gid  ||
+	     !user_ptrace_enabled) &&
 	    !capable(CAP_SYS_PTRACE)) {
 		rcu_read_unlock();
 		return -EPERM;
